Tp::Service::ChannelInterfaceRoomConfigAdaptor Class Reference

| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Public Member Functions | List of all members
Tp::Service::ChannelInterfaceRoomConfigAdaptor Class Reference
Channel service implementation

`#include <TelepathyQt/_gen/svc-channel.h>`

Inherits Tp::AbstractAdaptor.

## Public Slots
void | UpdateConfiguration (const QVariantMap &properties, const QDBusMessage &dbusMessage)

## Public Member Functions
bool | Anonymous () const
bool | InviteOnly () const
uint | Limit () const
bool | Moderated () const
QString | Title () const
QString | Description () const
bool | Persistent () const
bool | Private () const
bool | PasswordProtected () const
QString | Password () const
QString | PasswordHint () const
bool | CanUpdateConfiguration () const
QStringList | MutableProperties () const
bool | ConfigurationRetrieved () const
Public Member Functions inherited from Tp::AbstractAdaptor
| AbstractAdaptor (const QDBusConnection &connection, QObject *adaptee, QObject *parent)
| ~AbstractAdaptor ()
QDBusConnection | dbusConnection () const
QObject * | adaptee () const

## Detailed Description

Adaptor class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Channel.Interface.RoomConfig1".

## Member Function Documentation

bool Tp::Service::ChannelInterfaceRoomConfigAdaptor::Anonymous | ( |  | ) | const

Return the value of the exported D-Bus object property `Anonymous` of type `bool`.

Adaptees should export this property as a Qt property named 'anonymous' with type bool.

True if people may join the channel without other members being made aware of their identity.

Returns
  The value of exported property `Anonymous`.

bool Tp::Service::ChannelInterfaceRoomConfigAdaptor::InviteOnly | ( |  | ) | const

Return the value of the exported D-Bus object property `InviteOnly` of type `bool`.

Adaptees should export this property as a Qt property named 'inviteonly' with type bool.

True if people may not join the channel until they have been invited.

Returns
  The value of exported property `InviteOnly`.

uint Tp::Service::ChannelInterfaceRoomConfigAdaptor::Limit | ( |  | ) | const

Return the value of the exported D-Bus object property `Limit` of type `uint`.

Adaptees should export this property as a Qt property named 'limit' with type uint.

The limit to the number of members; or 0 if there is no limit.

Returns
  The value of exported property `Limit`.

bool Tp::Service::ChannelInterfaceRoomConfigAdaptor::Moderated | ( |  | ) | const

Return the value of the exported D-Bus object property `Moderated` of type `bool`.

Adaptees should export this property as a Qt property named 'moderated' with type bool.

True if channel membership is not sufficient to allow participation.

Returns
  The value of exported property `Moderated`.

QString Tp::Service::ChannelInterfaceRoomConfigAdaptor::Title | ( |  | ) | const

Return the value of the exported D-Bus object property `Title` of type `QString`.

Adaptees should export this property as a Qt property named 'title' with type QString.

A human-visible name for the channel, if it differs from ChannelInterfaceRoomInterface::RoomName ; the empty string, otherwise.

On XMPP, this represents the `muc#roomconfig_roomname` field of the `muc#roomconfig` form. So for `jdev@conference.jabber.org`, for example:

- ChannelInterfaceRoomInterface::RoomName = `"jdev"`;
- ChannelInterfaceRoomInterface::Server = `"conference.jabber.org"`;
- Title = `"General Jabber development discussion"`.

XEP-0045 is awful.

Returns
  The value of exported property `Title`.

QString Tp::Service::ChannelInterfaceRoomConfigAdaptor::Description | ( |  | ) | const

Return the value of the exported D-Bus object property `Description` of type `QString`.

Adaptees should export this property as a Qt property named 'description' with type QString.

A human-readable description of the channel's overall purpose; if any.

Returns
  The value of exported property `Description`.

bool Tp::Service::ChannelInterfaceRoomConfigAdaptor::Persistent | ( |  | ) | const

Return the value of the exported D-Bus object property `Persistent` of type `bool`.

Adaptees should export this property as a Qt property named 'persistent' with type bool.

`True` if the channel will remain in existence on the server after all members have left it.

Returns
  The value of exported property `Persistent`.

bool Tp::Service::ChannelInterfaceRoomConfigAdaptor::Private | ( |  | ) | const

Return the value of the exported D-Bus object property `Private` of type `bool`.

Adaptees should export this property as a Qt property named 'private' with type bool.

`True` if the channel is not visible to non-members.

Returns
  The value of exported property `Private`.

bool Tp::Service::ChannelInterfaceRoomConfigAdaptor::PasswordProtected | ( |  | ) | const

Return the value of the exported D-Bus object property `PasswordProtected` of type `bool`.

Adaptees should export this property as a Qt property named 'passwordProtected' with type bool.

`True` if contacts joining this channel must provide a password to be granted entry. Note that this property does not indicate that a password is required right now; see the ChannelInterfacePasswordInterface interface for the API used to provide a password while joining a room.

Returns
  The value of exported property `PasswordProtected`.

QString Tp::Service::ChannelInterfaceRoomConfigAdaptor::Password | ( |  | ) | const

Return the value of the exported D-Bus object property `Password` of type `QString`.

Adaptees should export this property as a Qt property named 'password' with type QString.

If PasswordProtected is `True`, the password required to enter the channel, if known. If the password is unknown, or PasswordProtected is `False`, the empty string.
On XMPP—bless its cotton socks!—non-owners of a MUC cannot see its current password, even if they just provided the password in order to join the room…

Returns
  The value of exported property `Password`.

QString Tp::Service::ChannelInterfaceRoomConfigAdaptor::PasswordHint | ( |  | ) | const

Return the value of the exported D-Bus object property `PasswordHint` of type `QString`.

Adaptees should export this property as a Qt property named 'passwordHint' with type QString.

If PasswordProtected is `True`, an optional hint for the password.

On protocols supporting PasswordHint (indicated by its presence in MutableProperties ), Password and PasswordHint MUST be set in a single call to UpdateConfiguration() .

Skype requires that the password and its hint be supplied together.

Returns
  The value of exported property `PasswordHint`.

bool Tp::Service::ChannelInterfaceRoomConfigAdaptor::CanUpdateConfiguration | ( |  | ) | const

Return the value of the exported D-Bus object property `CanUpdateConfiguration` of type `bool`.

Adaptees should export this property as a Qt property named 'canUpdateConfiguration' with type bool.

If `True`, the user may call UpdateConfiguration() to change the values of the properties listed in MutableProperties .

Returns
  The value of exported property `CanUpdateConfiguration`.

QStringList Tp::Service::ChannelInterfaceRoomConfigAdaptor::MutableProperties | ( |  | ) | const

Return the value of the exported D-Bus object property `MutableProperties` of type `QStringList`.

Adaptees should export this property as a Qt property named 'mutableProperties' with type QStringList.

A list of (unqualified) property names on this interface which may be modified using UpdateConfiguration() (if CanUpdateConfiguration is `True`). Properties not listed here cannot be modified.

For example, IRC does not have the concept of joining a room without other participants knowing your true identity; so on IRC the Anonymous property will always be `False`, and MutableProperties will not include `"Anonymous"`.

Returns
  The value of exported property `MutableProperties`.

bool Tp::Service::ChannelInterfaceRoomConfigAdaptor::ConfigurationRetrieved | ( |  | ) | const

Return the value of the exported D-Bus object property `ConfigurationRetrieved` of type `bool`.

Adaptees should export this property as a Qt property named 'configurationRetrieved' with type bool.

`True` once the initial room configuration has been retrieved, or `False` otherwise. On some services, this may take some time after you've joined a room to fetch the configuration. Once this property changes to `True`, the other properties on this interface can be assumed to be accurate; this property MUST not change to `False` after it becomes `True`.

An application's “configure this room” dialog might choose to display a spinner while this property is `False`, rather than allowing the user to edit probably-inaccurate configuration.

Returns
  The value of exported property `ConfigurationRetrieved`.

void Tp::Service::ChannelInterfaceRoomConfigAdaptor::UpdateConfiguration | ( | const QVariantMap & | properties,
|  | const QDBusMessage & | dbusMessage
| ) |  |
| slot

Begins a call to the exported D-Bus method `UpdateConfiguration` on this object.

Adaptees should export this method as a Qt slot with the following signature: void updateConfiguration(const QVariantMap& properties, const Tp::Service::ChannelInterfaceRoomConfigAdaptor::UpdateConfigurationContextPtr &context);

Implementations should call MethodInvocationContext::setFinished (or setFinishedWithError accordingly) on the received context object once the method has finished processing.

If CanUpdateConfiguration is `True`, modifies the current values of one or more room properties. This method SHOULD NOT return until the change has been accepted or declined by the server.

Note that the server may ostensibly accept the changes (thus allowing this method to return success) but signal different values; for example, the server might truncate Title to some maximum length. Callers SHOULD continue to listen for the `PropertiesChanged` signal, and trust the values it signals over those provided to this method.

Parameters

  properties | The new values of one or more properties on this interface, which must be listed in \\\ \\link requestPropertyMutableProperties() MutableProperties \\endlink \\htmlonly . For instance, to set up a channel for discussing top-secret corporate merge plans, this parameter might be:

>     {
>           'Private': True,
>           'InviteOnly': True,
>           'Description': "The first rule of #inteltakeover is: do not talk about #inteltakeover",
>         }